/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  cn.hutool.core.io.IoUtil
 *  com.deepexi.scd.calculate.config.MinioProp
 *  com.deepexi.scd.common.domain.FileInfoDTO
 *  com.deepexi.scd.common.enums.BaseExceptionEnum
 *  com.deepexi.scd.common.enums.ExceptionEnum
 *  com.deepexi.scd.common.exceptions.BusinessException
 *  com.deepexi.scd.common.extensions.ExDateTime
 *  com.deepexi.scd.common.extensions.ExString
 *  com.deepexi.scd.common.util.MinioService
 *  com.deepexi.spa.commons.utils.StringUtils
 *  io.minio.MinioClient
 *  io.minio.ObjectStat
 *  io.minio.messages.Bucket
 *  javax.servlet.ServletOutputStream
 *  javax.servlet.http.HttpServletResponse
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.stereotype.Component
 *  org.springframework.util.ObjectUtils
 *  org.springframework.web.multipart.MultipartFile
 */
package com.deepexi.scd.calculate.util;

import cn.hutool.core.io.IoUtil;
import com.deepexi.scd.calculate.config.MinioProp;
import com.deepexi.scd.common.domain.FileInfoDTO;
import com.deepexi.scd.common.enums.BaseExceptionEnum;
import com.deepexi.scd.common.enums.ExceptionEnum;
import com.deepexi.scd.common.exceptions.BusinessException;
import com.deepexi.scd.common.extensions.ExDateTime;
import com.deepexi.scd.common.extensions.ExString;
import com.deepexi.scd.common.util.MinioService;
import com.deepexi.spa.commons.utils.StringUtils;
import com.google.common.collect.Lists;
import io.minio.MinioClient;
import io.minio.ObjectStat;
import io.minio.messages.Bucket;
import java.io.InputStream;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.Optional;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.ObjectUtils;
import org.springframework.web.multipart.MultipartFile;

@Component
public class MinioUtils
implements MinioService {
    private static final Logger log = LoggerFactory.getLogger(MinioUtils.class);
    @Autowired
    private MinioClient minioClient;
    @Autowired
    private MinioProp minioProp;

    public void createBucket(String bucketName) {
        if (!this.minioClient.bucketExists(bucketName)) {
            this.minioClient.makeBucket(bucketName);
        }
    }

    public List<Bucket> getAllBuckets() {
        return this.minioClient.listBuckets();
    }

    public Optional<Bucket> getBucket(String bucketName) {
        return this.minioClient.listBuckets().stream().filter(f -> f.name().equals(bucketName)).findFirst();
    }

    public void removeBucket(String bucketName) {
        this.minioClient.removeBucket(bucketName);
    }

    public String getObjectURL(String bucketName, String objectName, Integer expires) {
        return this.minioClient.presignedGetObject(bucketName, objectName, expires);
    }

    public InputStream getObject(String bucketName, String objectName) {
        return this.minioClient.getObject(bucketName, objectName);
    }

    public InputStream getObject(String objectName) {
        return this.minioClient.getObject(this.minioProp.getBucketName(), objectName);
    }

    public void putObject(String bucketName, String objectName, InputStream stream) throws Exception {
        this.minioClient.putObject(bucketName, objectName, stream, (long)stream.available(), "application/octet-stream");
    }

    public void putObject(String bucketName, String objectName, InputStream stream, long size, String contextType) throws Exception {
        this.minioClient.putObject(bucketName, objectName, stream, size, contextType);
    }

    public ObjectStat getObjectInfo(String bucketName, String objectName) throws Exception {
        return this.minioClient.statObject(bucketName, objectName);
    }

    public void removeObject(String bucketName, String objectName) throws Exception {
        this.minioClient.removeObject(bucketName, objectName);
    }

    public FileInfoDTO uploadFile(MultipartFile file, String bucketName) throws Exception {
        if (null == file || 0L == file.getSize()) {
            throw new BusinessException((BaseExceptionEnum)ExceptionEnum.UPLOAD_FILE_CANNOT_NULL);
        }
        this.createBucket(bucketName);
        String originalFilename = file.getOriginalFilename();
        String fileName = bucketName + "_" + ExDateTime.getCurrentDataString() + this.getFileExtension(originalFilename);
        this.minioClient.putObject(bucketName, fileName, file.getInputStream(), file.getContentType());
        return this.getEndpointFileUrl(this.minioProp.getEndpoint(), bucketName, fileName);
    }

    public void download(String fileName, HttpServletResponse response) {
        this.download(this.minioProp.getBucketName(), fileName, response);
    }

    public void downloadReport(String fileName, HttpServletResponse response) {
        this.download(this.minioProp.getReportBucket(), fileName, response);
    }

    public void download(String bucket, String fileName, HttpServletResponse httpResponse) {
        ObjectStat stat = this.minioClient.statObject(bucket, fileName);
        InputStream inputStream = this.minioClient.getObject(bucket, fileName);
        byte[] buffer = new byte[1024];
        int length = 0;
        httpResponse.reset();
        httpResponse.setHeader("Content-Disposition", "attachment;filename=" + URLEncoder.encode(fileName, "UTF-8"));
        httpResponse.setCharacterEncoding("utf-8");
        ServletOutputStream outputStream = httpResponse.getOutputStream();
        while ((length = inputStream.read(buffer)) > 0) {
            outputStream.write(buffer, 0, length);
        }
        outputStream.close();
    }

    public void downloadFile(String fileName, String fileUrl, HttpServletResponse httpResponse, String contentType) throws Exception {
        String bucketName = this.minioProp.getBucketName();
        this.createBucket(bucketName);
        InputStream object = this.minioClient.getObject(bucketName, fileUrl);
        byte[] buffer = new byte[1024];
        int length = 0;
        httpResponse.reset();
        httpResponse.setHeader("Content-Disposition", "attachment;filename=" + URLEncoder.encode(fileName, "UTF-8"));
        httpResponse.setContentType(contentType);
        httpResponse.setCharacterEncoding("utf-8");
        ServletOutputStream outputStream = httpResponse.getOutputStream();
        while ((length = object.read(buffer)) > 0) {
            outputStream.write(buffer, 0, length);
        }
        outputStream.close();
    }

    public InputStream getWordFile(String fileUrl) throws Exception {
        this.createBucket(this.minioProp.getReportBucket());
        String prefix = "/" + this.minioProp.getReportBucket() + "/";
        fileUrl = fileUrl.substring(prefix.length());
        return this.minioClient.getObject(this.minioProp.getReportBucket(), fileUrl);
    }

    public String deleteFile(String fileName) {
        String bucketName = this.minioProp.getBucketName();
        try {
            this.minioClient.removeObject(bucketName, fileName);
        }
        catch (Exception e) {
            throw new BusinessException((BaseExceptionEnum)ExceptionEnum.DELETE_FILE_FAILED_FOR_SERVICE);
        }
        return "删除成功!";
    }

    public FileInfoDTO uploadFile(MultipartFile file) {
        String bucketName = this.minioProp.getBucketName();
        log.info("开始上传文件--------------------------------------------->");
        FileInfoDTO fileInfo = new FileInfoDTO();
        try {
            if (Objects.isNull(file)) {
                return fileInfo;
            }
            this.createBucket(bucketName);
            String fileName = file.getOriginalFilename();
            String fileExtension = this.getFileExtension(fileName);
            String newFileName = ExString.newUUID() + fileExtension;
            log.info("文件上传原始文件名：{}，新生成文件名：{}", (Object)fileName, (Object)newFileName);
            fileInfo.setFileName(newFileName);
            fileInfo.setFileSize(file.getSize());
            if (!ObjectUtils.isEmpty((Object)file) && StringUtils.isNotBlank((CharSequence)fileName)) {
                fileName = ExDateTime.getCurrentDateTimeString() + fileName;
                this.minioClient.putObject(bucketName, fileName, file.getInputStream(), file.getContentType());
                fileInfo.setServerUrl(this.minioProp.getEndpoint());
                fileInfo.setUrl(this.getFileUrl(fileName));
            }
            fileInfo.setOldFileName(fileName);
        }
        catch (Exception e) {
            log.info("上传文件异常：{}", (Object)e.getMessage());
            throw new BusinessException((BaseExceptionEnum)ExceptionEnum.UPLOAD_FILE_FAILED_FOR_SERVICE);
        }
        return fileInfo;
    }

    public String uploadWord(InputStream inputStream, String fileName) {
        return this.uploadWord(inputStream, fileName, this.minioProp.getReportBucket());
    }

    public String uploadWord(InputStream inputStream, String fileName, String bucketName) {
        String fileUrl = "";
        log.info("开始上传文件--------------------------------------------->");
        try {
            if (Objects.isNull(inputStream)) {
                return fileUrl;
            }
            this.createBucket(bucketName);
            String newFileName = ExString.newUUID() + "-" + fileName;
            log.info("文件上传原始文件名：{}，新生成文件名：{}", (Object)fileName, (Object)newFileName);
            if (!ObjectUtils.isEmpty((Object)inputStream) && StringUtils.isNotBlank((CharSequence)fileName)) {
                this.minioClient.putObject(bucketName, newFileName, inputStream, "application/msword");
                fileUrl = this.getWordUrl(bucketName, newFileName);
            }
        }
        catch (Exception e) {
            log.info("上传文件异常：{}", (Object)e.getMessage());
            throw new BusinessException((BaseExceptionEnum)ExceptionEnum.UPLOAD_FILE_FAILED_FOR_SERVICE);
        }
        return fileUrl;
    }

    public List<FileInfoDTO> uploadMultiFiles(MultipartFile[] files) {
        log.info("开始上传文件--------------------------------------------->");
        ArrayList<FileInfoDTO> fileInfoList = Lists.newArrayList();
        try {
            if (Objects.isNull(files) || files.length == 0) {
                return fileInfoList;
            }
            for (MultipartFile file : files) {
                fileInfoList.add(this.uploadFile(file));
            }
        }
        catch (Exception e) {
            log.info("上传文件异常：{}", (Object)e.getMessage());
            throw new BusinessException((BaseExceptionEnum)ExceptionEnum.UPLOAD_FILE_FAILED_FOR_SERVICE);
        }
        return fileInfoList;
    }

    private String getFileExtension(String fileName) {
        if (StringUtils.isBlank((CharSequence)fileName)) {
            return "";
        }
        int index = fileName.lastIndexOf(".");
        if (index < 0) {
            return "";
        }
        return fileName.substring(index);
    }

    private FileInfoDTO getEndpointFileUrl(String endpoint, String bucketName, String fileName) {
        FileInfoDTO dto = new FileInfoDTO();
        dto.setUrl("/" + bucketName + "/" + fileName);
        dto.setServerUrl(endpoint + dto.getUrl());
        dto.setFileName(fileName);
        return dto;
    }

    public String getFilePath(String fileName) {
        return this.minioProp.getEndpoint() + fileName;
    }

    private String getFileUrl(String fileName) {
        return "/" + this.minioProp.getBucketName() + "/" + fileName;
    }

    private String getWordUrl(String reportBucketName, String fileName) {
        return "/" + reportBucketName + "/" + fileName;
    }

    public InputStream getFileInputStream(String fileName) {
        String bucketName = this.minioProp.getBucketName();
        this.createBucket(bucketName);
        try {
            return this.minioClient.getObject(bucketName, fileName);
        }
        catch (Exception e) {
            log.error("minio服务异常:" + e.getMessage());
            throw new BusinessException((BaseExceptionEnum)ExceptionEnum.DOWNLOAD_FAILED);
        }
    }

    public byte[] download(String bucket, String path) {
        if (StringUtils.isBlank((CharSequence)bucket)) {
            bucket = this.minioProp.getBucketName();
        }
        try {
            InputStream inputstream = this.minioClient.getObject(bucket, path);
            return IoUtil.readBytes((InputStream)inputstream);
        }
        catch (Exception e) {
            log.error("minio服务异常:" + e.getMessage());
            throw new BusinessException((BaseExceptionEnum)ExceptionEnum.DOWNLOAD_FAILED, new Object[]{path});
        }
    }
}

